Last Comment Bug 93094 - [RFE] Add an archive mail feature (automatic archiving of messages per month /other interval)
: [RFE] Add an archive mail feature (automatic archiving of messages per month ...
Status: NEW
:
Product: MailNews Core
Classification: Components
Component: Backend (show other bugs)
: Trunk
: All All
: P5 enhancement with 62 votes (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
:
Mentors:
: 273326 297758 359427 445566 639466 (view as bug list)
Depends on:
Blocks: 423488
  Show dependency treegraph
 
Reported: 2001-08-01 08:17 PDT by jbwms
Modified: 2012-06-14 03:14 PDT (History)
42 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments

Description jbwms 2001-08-01 08:17:05 PDT
Add feature to allow user to archive their email and store it on removable 
media.  This is a way to reduce the size of the mail folder without losing any 
email.  My suggestion would be to add an option to make a mail folder point to 
the backup drive (CD, ZIP etc).
Comment 1 David :Bienvenu 2001-08-01 08:20:14 PDT
I'm not sure what you mean. You can make your mail directory be whatever you
want it to be, including an external media drive, if that's what you want. Or do
you just want a particular folder to be on a different drive? Or do you want the
ability to move/copy a folder to a different drive?
Comment 2 jbwms 2001-08-01 10:04:22 PDT
I guess either way would work.  Either have basically
two 'local' mail directories one that can point to
your main location and the other to point to the
archive.  Or you could make the actual location of the
folders variable.  In other words, under local mail
you could make a folder point to a removable drive.
Comment 3 David Balch 2002-04-16 12:37:04 PDT
If I may expand this a little, a feature I would like is the "Auto archive"
feature in Microsoft Outlook, incorporating:

1) Archiving rules for each mail folder.
2) Scheduling for how often to do the archiving.
3) Rules for determining which files to archive:
     3.1) Age
     3.2) Size
     3.3) Number of files in the folder (maybe?)
4) Choice of what to actually do when "archiving":
     4.1) Delete files (my interest)
     4.2) Move files to trash
     4.3) Move files to another folder (or drive)

(Probably not exactly as Outlook does it - I can't check having just discovered
that it won't start. Good job I use Moz :-)

Perhaps the rules (3) could use some of the code for the advanced find?

An example use: I have created a folder that all my bugzilla mail gets filtered
to. The number of mails gradually increases but I don't really need to keep the
old mails as I can check the actual bugpages. Therefore I want to say:
1) In Bugzilla folder.
2) Daily.
3) All emails older than 5 days.
4) Delete.

Ok, I could do this manually, but that's just not cool ;-)

For my interpretation of jbwms's request it would go:

1) In all folders.
2) Monthly.
3) All emails older than 5 months.
4) Move to /mnt/zip/mail.

Step (4) might be interesting, needing replication of mail folder hierarchy and
possibly some prompts about putting in the right zip (or whatever) disk...
Comment 4 James Harman 2002-11-22 17:42:39 PST
It would be nice to have this feature so that you could save off mail to a
backup folder (or cdrom).  The messages which were archived could be deleted
(maybe optional?).  VERY IMPORTANT would be to be able to archive a folder and
have the entire thing backed up  without having to select individual messages
for archiving.
Comment 5 Dan Bailey 2002-11-25 09:03:09 PST
What I'd like to see is just an extension of selecting an e-mail, clicking
File->Save As->File, entering a filename (something like
[sender]-[date/time]-[subject]) and saving as either plain-text or html, so that
a user can select certain e-mails, or the entire contents of one of their mail
folders, and then export that to disk. You could then backup the mail to
whatever you like.
Comment 6 Dan Rankin 2003-01-12 09:23:22 PST
Agree with Comment #5, with emphasis on ability to export all  messages in a
mail folder to individual .txt or .eml files in one step, with automatic
generation of unique file names.  As example, I recently found
http://expressarchiver.com/index.html which accomlishes that task for Outlook
Express.  Thank you.
Comment 7 Jon Roland 2003-01-23 12:36:41 PST
I suggest enhancement of the after-receipt filter function, to enable storage of
named "filters" (perhaps SQL-like select functions) that would operate
automatically to archive messages.

For example, I would like to set up an archiving system that would:

1 - Automatically move messages from Inbox to a standard folder (which could be
on a removable medium, so it would have to check for the presence of the medium)
that were received more than 30 days ago and during the month, to a
month-labeled folder, but not including messages flagged or labeled "To do" (and
perhaps other labels). In other words, on Jan. 1 the system would automatically
move messages received during November and not flagged or labeled to a folder
labeled, say, "In-200211" (for November, 2002, messages). This would require
messages to be timestamped on receipt. See Bug #190337.

2 - Automatically make a daily backup copy of messages in the Sent folder, and
on Jan. 1 move messages sent during November to a folder, which could be on a
removable medium, labeled "Sent-200211".

User might set up for prompts requesting permission to carry out the function,
or he could choose that they be done automatically without a prompt.

But the system must provide better for folders that are off-line, prompting the
user to insert the medium containing the folder (and keeping a record of the
medium identifier so that the user would know which medium to insert). The
absence of the medium with the folder should not just return an error, and
should definitely not cause Mozilla mail to malfunction.

Comment 8 Mark Stier 2003-10-17 12:16:54 PDT
Additional suggestion: provide an application independent export format (XML?).
Comment 9 Jon Roland 2004-02-07 12:43:34 PST
Any action on this. It is a continuing chore.
Comment 10 Dimitrios 2004-02-09 09:16:08 PST
There is an excellent Mozilla Backup app that's capable of archiving Moz,
Firebird or Thunderbird data,  at http://backup.jasnapaka.com/
Could it be embedded in Mozilla (assuming that the author provides the source)?
Comment 11 Dimitrios 2004-02-09 09:30:24 PST
Didn't notice that the application above runs under MPL licence. So actually it
IS possible to embed it in a Mozilla based product.
Comment 12 Michael Hall 2004-02-25 07:29:26 PST
I think the simplist method would be to extend the message filters to be run on
a schedule on specified folders, instead of just on incoming mail.  Then, extend
the  mail folders to allow you to specify the location of a specific folder. 
After that, all you have to do is set up a scheduled message filter to move old
emails from a certain folder to another 'archive' folder, then you can have that
'archive' folder stored locally, on removable media, or on a network share (for
businesses who want a central email backup).

The message filter functionality would also be better suited to be implemented
on a per-folder level, so that you can define a filter once, and have it run on
multiple folders, instead of applying all to just incoming mail.  For that
matter, add "when downloading mail" as an event in the scheduler, and the
scheduler will encompass all the functionality needed for both message filtering
and archiving.

So in short, the message filter engine should be dropped or re-worked to behave
like this:

1.) Filters are defined and stored in a single place.
2.) Each folder specifies which filters should be run on it, or each filter
specifies which folders it should be run in.
3.) Filters are run based on events such as downloading email, opening/closing
mozilla mail, or on a timed basis (every month/week/day/hour/minute/custom).
4.) Folders can have a path specified (individual folders in an account, not the
account as a whole), and optionally what format to store the email in: MBox
(default?), EML, txt, HTML, etc.

I realize this will require a good bit of code re-writing, but the added
functionality to the email client would be incredible, especially from a
corporate network admin's perspective.

Comment 13 Jon Roland 2004-02-25 08:56:11 PST
Michael Hall's Comment #12 would be a good solution if it were combined with a
solution to Bug #190337, indexing on the date/time actually received (from the
first header line) and even better, Bug #193538, providing a macro language,
which would support doing all this kind of archiving, filtering, etc. The macro
language should, however, support conditional branching and looping, and not
just be a system of SQL-like static expressions, the way the present filter
definitions are.
Comment 14 Keith Fetterman 2004-07-12 09:32:09 PDT
After reviewing the comments, I would like to add the following suggestions:

- provide a simple archiving mode and an advanced mode.  some of the suggestions
are very powerfull, but would be difficult for most users to implment.

- preserve the folder heirarchy in the archive directory when archiving nested
folders or archiving the entire mail folder tree (the entire mail folder hierarchy)

- allow the archived folder/folder hierarchy to be viewed in Mozilla.  Maybe
these could be appear like mail accounts or multiple "Local Folders" in the mail
folder view.  There could be an option to attach or add archive directories (a
directory containing archived mail folders) to the folder view.

For version 1 of this feature, it would be nice to be able to just archive based
on date, i.e., all mail that is over a xxxx days old.  Mozilla would them place
these email messages into a folder hierarchy that can then be viewed by Mozilla
later.
Comment 15 Aaron Lawrence 2004-10-11 03:46:43 PDT
*** Bug 97830 has been marked as a duplicate of this bug. ***
Comment 16 Seamaiden 2006-01-09 15:41:53 PST
This bug needs to be renamed to: 

[RFE] Add an archive feature to mozilla thunderbird and netscape mail

These keywords should be added:

mail1,mail6,access,helpwanted,relnote

Thunderbird needs to be able to archive mail and news messages. Update the ArchiveTools extension so that it works with Thunderbird 1.5 and 1.6.  Advanced users can do this now by unpacking the extension, changing the maxversion date, and repacking it. 

Add more features to that ArchiveTools extension. Let the user be able to select which folder(s) things get archived to. Make this extension part of Thunderbird.

Add a Keep button to the context menu in Thunderbird like in Agent Newsreader 3.1, so that you can mark which messages (mail or news) to keep and not delete or archive. This Keep feature should be made to work not only with the ArchiveTools extension, but also with the aging feature that is built into Thunderbird.

Create a temporary folder in Thunderbird for Archiving/Restoration. Suppose you want to archive just one subfolder of a folder? You need to be able to copy that subfolder to the temporary archive folder to be saved elsewhere on your hard drive. You also need to be able to import the folder again to a temporary restoration folder. Once imported, you can move the folder wherever you want within Thunderbird. If there is an existing folder of the same name, you MUST be given the choice whether to overwrite the existing folder or append that data to it so you don't lose any data.
Comment 17 Wade Van Buskirk 2006-05-03 09:21:36 PDT
Users want to move mail older then X days off an imap server inbox to another imap server annual archive. Users also want to move sentmail older then X days on the primary server to an annual folder on an archive imap server. We can build a filter to move messages older then X days, but it has no event other then for new messages hitting the inbox. However, incoming messages will not be older then X days. Seems like there just needs to be another filter event trigger and a 'target folder' rather then just working on 'incoming messages'.
Comment 18 Seth Goodman 2007-02-03 19:46:47 PST
The autoarchive feature in Outlook is the last feature that keeps me using that product as my main mail client.  What is needed is far from a simple backup, which is easy to arrange.  My motivation for doing this is when the local mail store gets very large, it occupies too much space on daily system backups, plus the MUA becomes sluggish.

The solution that was possible with Outlook was to automatically duplicate the structure of the local mail store in the archive folder.  That's not the only way to accomplish the goal, but it is one way that has proved convenient.  The other feature that has proved very useful is the ability to set different archive rules for each folder.  The only rules I use are age before archiving and the choice of whether to delete old messages or move them to the archive folder.  I have found it very useful to be able to set different ages for different folders.  There is a global autoarchive interval that I also use.
Comment 19 boris 2007-02-10 04:10:30 PST
Somehow I think that the whole concept of archiving should be thoroughly thought about and rigorously and fast implemented. (I mean Thunderbird or any e-mail client is supposed to be a repository of personal communication)
The following issues should be kept in mind:

- user interface - message management
  --automatically move old/unused data
  --automatically sort inbound data: threads or discussions (keep them together), signed/unsigned (verify), SPAM + prioritize (with learning filters - make it TB guess and approve it)
  --associate (auto group creation and context mapping) → a single mail might show up multiple times in different threads
  --keep the number of entries in the inbox below 20-100
  --timeline feature (showing when mail is archived - transparency) 
  --leave the possibility to integrate task and project management+appointments and scheduling (Mozilla Lightning) 

- keep quick access to archived data
  --make the archive mailbox searchable
  --maintain a list of subjects, senders, dates
  --give access to external search utilities (i.e. Google) for full-text search

- reduce the load off the client
  --reduce the size of the mailbox
  --separate attachments from content
  --minimize portion of data that has to be accessed every time (for thin clients - make the archived data available over the net - server based)

- save + store data
  --compress contents
  --externally save the archive (again server based archiving)

Of course not al of this can be included in the first place, but it should be kept in mind, when creating such an architecture. Thunderbird currently is not much advanced in the field of knowledge processing and maintenance than it was six years ago, when this thread started. And our mailboxes are growing and growing... and people still stick to commercial solutions... (even the ones who like OSS)
Comment 20 Mattias 2007-02-10 04:46:53 PST
Lots of great ideas here, and I'm sure I would use and come to depend on lots of these features.  However, not everyone thinks that 20-100 messages in the inbox is ideal.  I have several thousand messages in my inbox and that's how I like it.  I used number of messages in the inbox as an example, but the same argument can be made for all features discussed here, so please make them all optional (default=inactive).  Maybe a new "Organize" button could be a starting point for choosing/configuring these features.  Thanks!
Comment 21 Lewis Rosenthal 2007-02-10 08:09:39 PST
As Mattias has pointed out, there are lots of good ideas in this thread, going back to the beginning. Basic archiving is available using the filter functionality we now have (message older than X days, move to Y), though it is - as pointed out in comment #12 - limited to running only during retrieval passes (which isn't necessarily a bad thing, as most of us POP mail every few minutes, anyway).

For IMAP, such things are usually available server-side, and should not involve the mail client at all. If local archiving is desired, then the above filter rule should work, possibly with an added "delete message" parameter (my IMAP server only copies when messages are moved, unless I tell it specifically to delete).

In short, I think what may be required at this point, beyond anything else (aside from a new database approach to message storage entirely, which is beyond the scope of this RFE) is a better UI for performing archival functions. The underlying mechanics seem to be pretty much in place. Mattias has again pointed to this in comment #20, with his idea of an "Organize" button. I could see this more as a menu item and/or a pref setting with an optional toolbar button, but essentially all it would do would be to set up and then fire off a series of filters. In the pref, merely check off the folders you want to have archived on each pass (akin to the UI for subscribing to IMAP folders or NG), check an option to have newly created folders auto-added to the archive list, and then the location of the archive file(s), which would essentially be just another mail account which would not check for mail or have the ability to send.

Anyway, just a few more thoughts to get some rudimentary UI stuff going.
Comment 22 Wayne Mery (:wsmwk, NI for questions) 2007-06-22 05:12:51 PDT
This is an issue for "enterprises" and it is worth noting that firefox has initiated an effort to improve the attractiveness of FF to enterprises.
Comment 23 Joshua Cranmer [:jcranmer] 2008-06-05 15:56:13 PDT
*** Bug 297758 has been marked as a duplicate of this bug. ***
Comment 24 jouan.y 2008-07-02 09:01:26 PDT
Hi all,

I am looking for a way to archive as MS Outlook.
It is very easy then, to access its archived messages

Regards
Comment 25 Joshua Cranmer [:jcranmer] 2008-07-16 13:11:34 PDT
*** Bug 445566 has been marked as a duplicate of this bug. ***
Comment 26 Jon Roland 2008-07-16 23:42:51 PDT
I somewhat disagree with the recent changes in the title of this bug and the direction it seems to be taken in recent posts. It is already easy enough to set any or all the folders in Local Folders to an external medium, which can be mounted when one wants to read the contents. The real need is to set up automatic moving or copying of messages to archive folders in a way that preserves ease of finding archived messages.

What I do presently is define a folder in Local Folders on an external medium for each month, with a name In-200807 for July of 2008, and manually move all the email from the Inbox received during that month to that folder, That is a tedious chore that I would like to automate. It has also been unsatisfactory that messages are not datestamped with the time and date of receipt so the split can be made cleanly. It is also unsatisfactory that there is no automatic backup of the Inbox, to prevent loss of its contents if TB crashes.

What I mean by an archive function would work like this:
1. Put either Local Folders, or an Archive account, on another drive, probably an external one.
2. Datestamp every message with the date and time of arrival in the Inbox.
3. Set up automatic archive folders, one for each month, to which contents of the Inbox for that month are automatically  moved at some set point, say a week after the end of the month, during off hours, and only if the external medium is mounted. If not mounted, moving would be ddeferred until it was mounted.
4. Inbox would be automatically compacted after successful move of a month of email.
5. Automatic backup of any or all folders to yet other external media, if mounted, at scheduled intervals or triggering events (such as power failure).
6. Allow for the option of a month of messages being added to an existing folder rather than a new one, if there aren't too many messages in it.

This is much more like what is done with Outlook or other professional products.
Comment 27 Matěj Cepl 2008-07-17 02:13:59 PDT
Totally agree with Jon -- this bug is not about moving stuff on the floppy/CD, but about automatic archiving of expired messages to somewhere else. One note though -- Jon considers only the eventuality that one uses one huge INBOX for all his messages. I would like other architecture -- folder Archive (be it on the different device or in the same location as other folders), with subfolders named by year, where the current hierarchy of other folders than Archive would be copied. So in the simple case

/
 Archive
     2007
        INBOX
        Personal
        Work
     2008
        INBOX
        Personal
        Work
 INBOX
 Personal
 Work

Of course in case the "other" hierarchy is changed, it shouldn't change hierarchies from the PAST years
Comment 28 Jon Roland 2008-07-17 02:51:49 PDT
No, I don't consider only one huge Inbox for all messages. It happens that the Inbox of one account gets more than 3000 messages a day, but that is not typical of the others. Because of the way asubfolders currently work I contemplate something more like this:

Account 1
    Inbox
    Sent
    Junk
    Trash
    Other folders
Account 2
    Inbox
    Sent
    Junk
    Trash
    Other folders
Account 3
    Inbox
    Sent
    Junk
    Trash
    Other folders
...
Local Folders
...
Archive
Account 1
    In-200701
    In-200702
    In-200703
    In-200704
    In-200705
    In-200706
    In-200707
    In-200708
    In-200709
    In-200710
    In-200711
    In-200712
    In-200801
    In-200802
    In-200803
    In-200804
    In-200805
    In-200806
    In-200807 (building as messages come in)
    Sent-2007
    Sent-2008 (building as messages come in)
    Other folders
Account 2
    In-2007
    In-2008 (building as messages come in)
    Sent-2007
    Sent-2008 (building as messages come in)
    Other folders
Account 3
    In-2007
    In-2008 (building as messages come in)
    Sent-2007
    Sent-2008 (building as messages come in)
    Other folders

In other words, the breakout intervals would depend on the rate at which various account inboxes get messages. In this case, Account 1 gets broken out by month, but if email volume was even heavier, it might be by week or even by day.

Comment 29 Jon Roland 2008-07-17 03:41:29 PDT
To further explain what I have in mind, I would have:

* Account 1 Inbox would contain messages from July and last week of June.

* Archive Account 1 In-200806 would contain only copies of all messages from the first 3 weeks of June, but would contain duplicate those of the last week of June.

* On August 1 at midnight a new folder 200808 would be automatically created, if the arcjhive medioum were mounted,  and copies of messages in Account 1 Inbox would be put there. Also, the last week of June messages would be deleted from Inbox so that the only copies would be in In-200806. No further messages would go into In-200807.

The reason for retaining the messages of the last week of the previous month is to allow easy viewing for those messages in the current Inbox without having to go to the archive. The setup could make that longer or shorter, or retain the messages of the last week of the previous month in the Inbox only until the beginning of the second week of the month. Other options would be available.

If the archive medium went unmounted for several months messages would just accumulate in their original folders. Once mounted, the system would wait, by default, until the designated time, say 3:00 AM, then get caught up on archiving the accumulated messages.

Warning messages would be issued to the user if the archive medium went unmounted for more than, say, a month.

The system would allow for the mounting of new, empty archive media, so long as the new medium had the folder structure of the old one down to the account level. It would create new folders as needed to receive messages to be archived as described above. This would allow for a succession of media as previous ones get filled up.

If an archive medium does not have enough space, the user is prompted to replace it with an empty one, the folder structure for not-yet-archived messages will be copied over, and archiving will resume. There will be an option to back out archiving from a previous medium so it can be put on the next one, to avoid splitting messages between media.

There might also be a similarly operating archive for address books, automatically moving old or not recently used addresses to an archive folder that could be read when the archive medium is mounted. If one used an address that had been archived, it would be moved back to the current address book. Links would be maintained so that the user could easily determine which addressees had been sent which messages.
Comment 30 Jon Roland 2008-07-17 03:50:18 PDT
Incidentally, if this feature is added, it would create a need for another enhancement that may deserve to be a separate bug, to enable a message find on more than one folder at a time, so that, for example, one could search all the messages for several years in the archive in a single operation, if one didn't know the date range of the one the user is seeking.
Comment 31 Valerio Messina 2008-07-17 12:27:03 PDT
the smallest brick to implement those specifications seems to be:
- select any folder (on IMAP4 server, Pop3 Inbox or local folder)
- right click on that folder, choose the function Archive.
A dialog box open, the user can select:
- a date. Mail older that date will be archived.
- the destination path DST where create the archive
Moz shold create a file struct like local folder, starting from selected folder, and all subfolder, and then MOVE there all the mail matching the date range, respecting the folders tree positions.

The Restore function maybe something like this:
- select any folder (on IMAP4 server, Pop3 Inbox or local folder)
- right click on that folder, choose the function Restore.
A dialog box open, the user can select:
- the path where find the archive of mails.
Moz should mount the archived mail and all the subfolder in this mount point as a subfolder tree.

If I'm not wrong, other mail client work in this manner.
Comment 32 Magnus Melin 2008-07-18 11:33:23 PDT
Maybe this summary is better then... : [RFE] Add an archive mail feature (automatic archiving of messages per month /other interval) 
Comment 33 Quinn Yost (mythdraug) 2008-07-18 13:56:34 PDT
Much improved summary.    

The old summary would be Bug 97830.
Comment 34 vic 2008-09-29 11:58:54 PDT
At risk of introducing something that is really dumb or not exactly for this thread....  here goes....

I've been using classic Eudora since the first year it was introduced and since then have been faithfully archiving my email folders annually, by year, so some day in the sweet by and by, I or my family members may have a historical record of of my business and personal life (my whole life pre-Facebook is on my emails).

The challenge of course is to archive in  a way that the archive itself doesn't fall victim to changing technology becoming lost to obsolescence.

I mean-- making sure an archive is always retrievable and not dependent on a proprietary mechanism.  Like right now-- With classic Eudora heading to the sunset, in my own current computer upgrade cycle with Vista I'm having difficulty accessing those old proprietary mail folders. I'd love to be able to get at them, even in txt format.

So, my suggestion is to include an "exportable" archiving function that allows universal access to a mail folder apart from trusting that Eudora or Thunderbird will always be there after Jesus returns etc.

In the rawest form an export standard might be to convert mail to a single html file-- Xanga did that to archive their blogs... or simply to a txt format importable into a spreadsheet or database, or viewable file-by-file (where every email is a text or html file)

Anyway-- I just toss that out there as a long time end-user for your consideration.

Thanks,
Vic
Comment 35 Matěj Cepl 2008-09-29 14:33:09 PDT
(In reply to comment #34)
> With classic Eudora heading to the sunset, in my own current computer upgrade
> cycle with Vista I'm having difficulty accessing those old proprietary mail
> folders. I'd love to be able to get at them, even in txt format.

Except, they are not ... that is the old proprietary mail folders. They use the same mbox folder format as Thunderbird. It is not completely pain-free (see
http://kb.mozillazine.org/Importing_from_Eudora_(Thunderbird) for more details), but the conversion is certainly possible.
Comment 36 Lewis Rosenthal 2008-09-30 17:38:58 PDT
(In reply to comment #34)


> The challenge of course is to archive in  a way that the archive itself doesn't
> fall victim to changing technology becoming lost to obsolescence.
> 
> I mean-- making sure an archive is always retrievable and not dependent on a
> proprietary mechanism.  Like right now-- With classic Eudora heading to the
> sunset, in my own current computer upgrade cycle with Vista I'm having
> difficulty accessing those old proprietary mail folders. I'd love to be able to
> get at them, even in txt format.
> 
> So, my suggestion is to include an "exportable" archiving function that allows
> universal access to a mail folder apart from trusting that Eudora or
> Thunderbird will always be there after Jesus returns etc.
> 

Vic, per comment #35, messages are now stored in mbox format which has been almost a standard (okay, so there are several incompatible flavors) for over a decade (see http://en.wikipedia.org/wiki/Mbox). There are indeed external tools which allow access to Mozilla mbox files (follow the external links at the bottom of the referenced page).

I would argue that the archiving mechanism either stores archives in mbox format or in sqlite databases, the latter of which are infinitely more reliable than mbox (text) files.

An export function would be a separate RFE, AFAIC. The thrust of this RFE is:

    Add feature to allow user to archive their email and store it on removable 
    media.

The requester suggests being able to access the archive from within MailNews (or Thunderbird, as things have progressed, I would imagine), so the issue of archive format must be one supported natively by MailNews. Exporting implies being able to copy/move the messages to an intermediate format for use in some sort of "import" function elsewhere.

Just my perspective.
Comment 37 Matt Dudziak 2009-01-27 15:54:03 PST
*** Bug 359427 has been marked as a duplicate of this bug. ***
Comment 38 disgustipated 2009-03-19 11:13:24 PDT
(In reply to comment #30)
> Incidentally, if this feature is added, it would create a need for another
> enhancement that may deserve to be a separate bug, to enable a message find on
> more than one folder at a time, so that, for example, one could search all the
> messages for several years in the archive in a single operation, if one didn't
> know the date range of the one the user is seeking.


I perform searches on emails for work that I might not have any idea of the date range. The current way archive is set up in 3.0b3pre it splits the emails into folders organized like:
archive
-year
  --month
  --month

The way I work with Thunderbird 2, I really like being in 3 pane view and able to use the quick search in the top right and have all the emails from the currently selected folder matching the search show up in the middle pane and the preview on the far right pane. With the emails being broken out by month I am unable to do this. I could use the Search Message window accessed by shift+ctrl+f but it is clunky as I am unable to preview the message and have to open each one to skim through it or open the attachment.

Perhaps this could be solved by a recursive search option added to the quicksearch box or adding the option of how to archive for example only archive into folders by year or option to achive folders by year>month.
Comment 39 IagoSRL 2010-04-10 13:18:08 PDT
I think this feature ('autoarchive') could be implemented by add the option 'archive' in the current 'Retention Policy' settings (per account and per folder -maybe only IMAP accounts and folders-), using the existing archive feature included with TB3.0+ with the settings defined per account (archive granularity, destination folder, keep folders scheme -Bug 522761-).

An exception will be the folder designed to contain the archived mail, because this and all its subfolders must be skipped in the autoarchive process (when the retention policy are applied by TB).

With this, the options in the 'Retention Policy' will be:
 - Don't delete any messages
 - Delete all but the most recents XXX messages
 - Delete messages more than YY days all
 - Archive messages (using the account archive settings)  <- Our new option

What do you think? Can be 'the place' where the autoarchive feature must be in Thunderbird?
Comment 40 Jean-Marie COUPRIE 2011-04-13 11:06:05 PDT
A) My configuration
I have not yet used Archive function. The oldest messages are dated mid 2002. The present total size of mailboxes with .msf is 207 M Octets. I have 8 accounts (POP3) with a total of 241 mailboxes out of which approximatively 220 are candidates for archiving. I don't have IMAP accounts.
 I currently use available functions to decrease manually the size e.g. detaching or erasing the attachments from "inbox", "sent" or any other big mailboxes, creating user defined mailboxes (filling them using filters) : this distributes the total size in many parts, avoids too big mailboxes and eases search. I erase periodically uninteresting messages (e.g ack, obsolete messages, blablabla, Junk, Trash, etc.)

B) Interesting bugs already existing
A search on "archiv" has given to me :
Bug  93094 - [RFE] Add an archive mail feature (automatic archiving of messages per month /other interval) (THIS ONE)
Bug 473212 - tracking bug for finishing Archive feature in TB 
Bug 479823 - Archive function: archive filter rules 
Bug 481185 - Remove all attachment when Archiving 
Bug 561617 - Add Semester and Quaterly Archive possibility 
Bug 607295 - Provide UI for new archive granularity and folder structure options
Bug 639466 - Automatic archiving as retention policy 
I have not listed bugs on IMAP problems.

C) Functionalities and UIS
I need several functionalities and UIs to use the archive function :
Of course, they reflect what the user wish to do. So before discussing functionalities and UIs we have to discuss the uses.
1) Definition of archive folders and their structure and content.
-The "archived" contents are what I don't need to keep in the "current" mailboxes with fast and permanent access. Many actions are repeated each year : Xmas, New Year and birthdays have fixed dates but Easter, summer or winter vacations have moving dates so I think that I have to keep a full year plus a margin (something between 365 and 465 days). This seems to be the most logical choice and does not cause problems for me because my accounts have a big quota (1 GO. or more) and I don't receive too many mails/accounts. With smaller quota or plenty of mails I may have chosen a shorter time.
-Structure of archived folders : from above, I'll choose the "Yearly Archived Folders" with the option "to keep the original folder structure in the archives hierarchy" because I am happy with my present structure of many mailboxes that make easy to find a message. See bugs 607295 and 561617 which gives more flexible choice.
 I need clarifications : if I have selected a range of messages encompassing 2 years (e.g. 2008 and 2009) does the messages go to the year of their dates or to the year of the archiving command (difficult to accept)?
-I'll consider the archived folders as a kind of back-up. That means several things : archiving should be a very secure process probably appending to a temporary file containing a copy of the already existing archive folder and renaming at the last second (I think that a similar method is used when compacting mailboxes), the destination folder (with the name of the archived email account somewhere in its directory) has to be on an external disk that is not permanently connected or powered-on (to avoid destruction when my PC is destroyed by a catastrophic event). The archived messages should be suppressed (by a compact ?) from the current mailbox only if the archiving is succesfull.
-I'll have to back-up the "current" mailboxes periodically as all other files of my disk. Archiving should not make normal back-up more difficult. As archiving may change dormant mailboxes by suppressing old messages, I have no interest in archiving too often (e.g each day or hour).
-How many times the archiving function should be repeated ? With "Yearly Archived Folders" I assume that archiving once a month is sufficient. How many mailboxes do I have to archive ? Five mailboxes are defined at the creation of each account but user can define many others and move to them the incoming mail (automatically by filters) and even the outgoing mail (manually by filters). Inbox and Sent may be big and have to be archived periodically, so are user defined mailboxes, Drafts should be small or empty, Junk or Trash can be periodically erased. Templates are created when a first message is saved as template ; It is normally small and you keep it available without archiving it. That means at least 2 mailboxes to archive per account. In my particular case, approximatively 220 mailboxes are to be archived. I think that archiving mailbox by mailbox (as presently defined) is acceptable up to a dozen of times but becomes a show stopper at 2 dozens or more. So a more powerful method e.g. archiving account by account is needed : an idea is to archive all the messages that are older than xxx days for all the mailboxes of the account with only 1 command. An UI may be to apply the presently defined function when a mailbox is selected and the more powerful method when an account is selected.

2) I need to access or search the archived folders.
How ? Which is the UI ?
The ideal solution is that they can be accessed or searched the same way as the "current" (not archived) mailboxes. The possibility of moving/copying a message from an archived mailbox to an other (archived or not) allow to correct an error of location or to undo archiving.

3) There is a particular account : the one specialized to receive my subscriptions to forums, bugzilla, newsletters, etc. .
 Why specialized ? because the corresponding userid is rapidly spammed so I use a Gmail account which have a very effective spam protection. Some sites do not apply the anti-spam rule to never publish user mail address (e.g. bugzilla, developers forums, etc.), other may sell addresses (I have not the proof) or be compromised.
 Why particular ? because I do not need to keep all the messages saying that a particular bug or forum has been modified : the last one is sufficient. A newsletter that is more than 3 to 6 months old has no more interest. A program of music or theatre should be discarded when its period is finished probably a month.
 Can erasing messages be considered as archiving ? Yes, it is archiving in a "garbage can" folder (the thrash mailbox) common to the whole account...
 What function do I need ? When the mailbox is used for newsletter(s), I need, per subject (in case the same mailbox is used for several), the last occurrence and all the others that are more recent that xxx days. For notification that a particular bug or forum has been modified I need to keep only the most recent occurrence of each subject (in case the same mailbox is used for several bugs or forums). To summarize, I need, per subject, the last occurrence and all the others that are more recent that xxx days, xxx being equal to 1 in some cases and changing with the mailbox. I do not accept to use only archive by age because the last occurrence may disappear and I use it as an URL to reach the subject !
Can this function be added in the UI or is an other bug needed ?

4) Rules for archiving
As stated in 2) the present function limited to manually select messages in a particular mailbox then press a button to archive is very flexible but not acceptable when you have many mailboxes.
 A more automatic method is needed archiving by mail account or all the accounts at a time. So rules should be created.
-Start of archiving : manually or automatically by a time machine. As the back-up external disk should be connected before, I propose to use the time machine of the back-up function that normally accept scripts to be executed before or after back-up.
-normal accounts : there are some mailboxes that do not need to be archived (see 1) )e.g. Drafts, Junk, Trash, Templates. Others should be archived if they are older than xxx days. I'll be happy to have, per account, a default value for xxx days and a list of exceptions e.g. "Junk \ 99999" mens that "junk" is never archived. Not too much entries !
-subscriptions accounts (see 3) ) : in fact it is deletion rules. there should be the choice, per mailbox, between : delete if older than xxx days, keep only the most recent occurrence of each subject (in case the same mailbox is used for several bugs or forums), keep per subject (in case the same mailbox is used for several) the last occurrence and all the others that are more recent that xxx days or keep a limited number of them, define a default action for non listed mailboxes. 
-mixed accounts : choice between actions defined in normal and subscriptions accounts... Do we need other actions ?

5) Bug 481185 - Remove all attachment when Archiving 
may be a good idea to finish my manual cleaning, see A).
Comment 41 Matěj Cepl 2011-04-14 04:55:37 PDT
(In reply to comment #38)
> The way I work with Thunderbird 2, I really like being in 3 pane view and able
> to use the quick search in the top right and have all the emails from the
> currently selected folder matching the search show up in the middle pane and

I think this could be really a matter of another bug ... please, keep this only about how to make an archive folders. Their search, indexing etc. should go to separate bugs.
Comment 42 Matěj Cepl 2011-04-14 05:01:30 PDT
*** Bug 639466 has been marked as a duplicate of this bug. ***
Comment 43 Jo Hermans 2012-06-14 03:14:57 PDT
*** Bug 273326 has been marked as a duplicate of this bug. ***

Note You need to log in before you can comment on or make changes to this bug.